﻿using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;

namespace Change_cells_border_margin_style
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.gridControl1[3, 3].CellType = "ComboBox";
            this.gridControl1[3, 3].ChoiceList = new System.Collections.Specialized.StringCollection() { "1", "2", "4" };
            this.gridControl1[1, 4].CellValue = "Example";
            this.gridControl1[2, 4].CellValue = "Date";
            this.gridControl1[3, 5].CellValue = "Sample";
            this.gridControl1[3, 5].BackColor = Color.Aquamarine;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.gridControl1.ColStyles[3].BackColor = Color.LightGreen;
            //this.gridControl1.Model.BaseStylesMap.Standard = new GridBaseStyle();
            this.gridControl1.RowStyles[5].BackColor = Color.Aquamarine;
        }

        //To Serialize the Style
        private void serializeBtn_Click(object sender, EventArgs e)
        {
            Stream s = File.Create("GridStyle");
            XmlWriter xmlWriter = new XmlTextWriter(s, Encoding.Default);
            //To serialize the Columns
            XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridStyleInfo));
            xmlSerializer.Serialize(xmlWriter, this.gridControl1.Model.ColStyles[3]);
            
            ////To serialize the base style
            //XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridBaseStyle));
            //xmlSerializer.Serialize(xmlWriter, this.gridControl1.Model.BaseStylesMap.Standard);
            ////To serialize the rowstyle
            //XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridStyleInfo));
            //xmlSerializer.Serialize(xmlWriter, this.gridControl1.Model.RowStyles[5]);

            s.Close();
        }
        //To deserialize the style
        private void button2_Click(object sender, EventArgs e)
        {
            Stream s = File.OpenRead("GridStyle");
            XmlReader xmlReader = new XmlTextReader(s);
            //To deserialize the column styles alone
            XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridStyleInfo));
            this.gridControl1.Model.ColStyles[3] = (GridStyleInfo)xmlSerializer.Deserialize(xmlReader);
            
            ////To deserialize the basestyle
            //XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridBaseStyle));
            //this.gridControl1.Model.BaseStylesMap.Standard = (GridBaseStyle)xmlSerializer.Deserialize(xmlReader);
            ////To deserialize the rowstyles alone
            //XmlSerializer xmlSerializer = new XmlSerializer(typeof(GridStyleInfo));
            //this.gridControl1.Model.RowStyles[5] = (GridStyleInfo)xmlSerializer.Deserialize(xmlReader);
            s.Close();
            this.gridControl1.Refresh();
        }
    }
}